static const char *RcsId = "$Id:  $";
//+=============================================================================
//
// file :         Keithley6221.cpp
//
// description :  C++ source for the Keithley6221 and its commands. 
//                The class is derived from Device. It represents the
//                CORBA servant object which will be accessed from the
//                network. All commands which can be executed on the
//                Keithley6221 are implemented in this file.
//
// project :      TANGO Device Server
//
// $Author:  $
//
// $Revision:  $
//
// $Revision:  $
// $Date:  $
//
// SVN only:
// $HeadURL: $
//
// CVS only:
// $Source:  $
// $Log:  $
//
// copyleft :     European Synchrotron Radiation Facility
//                BP 220, Grenoble 38043
//                FRANCE
//
//-=============================================================================
//
//  		This file is generated by POGO
//	(Program Obviously used to Generate tango Object)
//
//         (c) - Software Engineering Group - ESRF
//=============================================================================



//===================================================================
//
//	The following table gives the correspondence
//	between commands and method name.
//
//  Command name  |  Method name
//	----------------------------------------
//  State         |  dev_state()
//  Status        |  dev_status()
//  AutoRangeOFF  |  auto_range_off()
//  AutoRangeON   |  auto_range_on()
//  GetRange      |  get_range()
//  Off           |  off()
//  On            |  on()
//  RangeDOWN     |  range_down()
//  RangeUP       |  range_up()
//
//===================================================================


#include <tango.h>
#include <Keithley6221.h>
#include <Keithley6221Class.h>
#include <TypesAndConsts.h>

namespace Keithley6221_ns
{
//-----------------------------------------------------------------------------
//- Check Interface macro:
#define CHECK_INTERFACE \
	if (! this->m_interface) \
	{ \
	THROW_DEVFAILED(_CPTC("INTERNAL_ERROR"), \
	_CPTC("request aborted - the socket Interface isn't properly initialized"), \
	_CPTC("Keithley6221::check_interface")); \
	}
//+----------------------------------------------------------------------------
//
// method : 		Keithley6221::Keithley6221(string &s)
// 
// description : 	constructor for simulated Keithley6221
//
// in : - cl : Pointer to the DeviceClass object
//      - s : Device name 
//
//-----------------------------------------------------------------------------
Keithley6221::Keithley6221(Tango::DeviceClass *cl,string &s)
:Tango::Device_4Impl(cl,s.c_str())
{
	init_device();
}

Keithley6221::Keithley6221(Tango::DeviceClass *cl,const char *s)
:Tango::Device_4Impl(cl,s)
{
	init_device();
}

Keithley6221::Keithley6221(Tango::DeviceClass *cl,const char *s,const char *d)
:Tango::Device_4Impl(cl,s,d)
{
	init_device();
}
//+----------------------------------------------------------------------------
//
// method : 		Keithley6221::delete_device()
// 
// description : 	will be called at device destruction or at init command.
//
//-----------------------------------------------------------------------------
void Keithley6221::delete_device()
{
	yat4tango::TraceHelper t("Keithley6221::delete_device", this);

	//	Delete device allocated objects
	if(m_interface)
	{
		delete m_interface;
		m_interface = 0;
	}

	if(m_deviceProxy)
	{
		delete m_deviceProxy;
		m_deviceProxy = 0;
	}

	//- remove the inner appender
	yat4tango::InnerAppender::release(this);
}

//+----------------------------------------------------------------------------
//
// method : 		Keithley6221::init_device()
// 
// description : 	will be called at device initialization.
//
//-----------------------------------------------------------------------------
void Keithley6221::init_device()
{

	m_autoRange = false;
	m_range = "";
	m_current = 0.0;
	m_deviceProxy = NULL;
	m_interface = NULL;
	m_init_ok = false;
	m_status = "";
	m_compStatus = "No information";
	m_currStatus = "No information";

	//- initialize the inner appender (first thing to do)
	try
	{
		yat4tango::InnerAppender::initialize(this, 512);
	}
	catch( Tango::DevFailed& df )
	{
		ERROR_STREAM << df << std::endl;
		set_state(Tango::FAULT);
		m_status = "initialization failed - could not instanciate the InnerAppender";
		return;
	}

	//- trace/profile this method
	yat4tango::TraceHelper t("Keithley6221::init_device", this);

	// Initialise variables to default values
	//--------------------------------------------
	try
	{
		this->get_device_property();
	}
	catch (Tango::DevFailed & df)
	{
		ERROR_STREAM << df << std::endl;
		m_status = "initialization failed - <get_device_property> failed [see device log for details]";
		set_state (Tango::FAULT);
		return;
	}
	catch (...)
	{
		ERROR_STREAM << "initialization failed - unknown <get_device_property> error" << std::endl;
		m_status = "initialization failed [unknown <get_device_property> error]";
		set_state (Tango::FAULT);
		return;
	}

	//- get access to the socket device
	try
	{
		m_deviceProxy = new Tango::DeviceProxy(currentSourceProxyName);
		int l_res = m_deviceProxy->ping();
		DEBUG_STREAM << "The SocketDevice proxy pings at " << l_res << std::endl;
		Tango::DevState l_state = m_deviceProxy->state();
		
    if ((l_state != Tango::OPEN) && (l_state != Tango::ON)) 
		{
			ERROR_STREAM << "initialization failed - the socketDevice is not OPEN." << std::endl;
			m_status = "initialization failed [the socketDevice is not OPEN.]";
			set_state (Tango::FAULT);
			return;
		}
	}
	catch (...)
	{
		ERROR_STREAM << "initialization failed - failed to access the socketDevice" << std::endl;
		m_status = "initialization failed [failed to access the socketDevice]";
		set_state (Tango::FAULT);
		return;
	}

	try
	{
		m_interface = new keithley6221Interface(m_deviceProxy);

		CHECK_INTERFACE;

		//- check if the identification is accessible, if not, The socket device isn't well configured or the equipment is off or not connected.
		std::string l_strid = m_interface->read_id();
		DEBUG_STREAM << "initialization : ID : " << l_strid << std::endl;
	}
	catch (...)
	{
		ERROR_STREAM << "initialization failed - failed to create interface. The socket device isn't well configured or the equipment is off or not connected." << std::endl;
		m_status = "initialization failed [failed to create interface]\nThe socket device isn't well configured or the equipment is off or not connected.";
		set_state (Tango::FAULT);
		return;
	}

	//- set the equipment in initial conditions
	m_autoRange = m_interface->read_autorange();
	m_range = Tango::string_dup(m_interface->read_range().data());
	try
	{
		m_interface->write_compliance(voltageCompliance);
	}
	catch (...)
	{
		ERROR_STREAM << "initialization failed - failed to set the voltage compliance." << std::endl;
		m_status = "initialization failed [failed to set the voltage compliance.]";
		set_state (Tango::FAULT);
		return;
	}
	m_init_ok = true;
	set_state(Tango::STANDBY);
	m_status = "The device is up and ready";
	m_currStatus = "No Error";
}


//+----------------------------------------------------------------------------
//
// method : 		Keithley6221::get_device_property()
// 
// description : 	Read the device properties from database.
//
//-----------------------------------------------------------------------------
void Keithley6221::get_device_property()
{
	//	Initialize your default values here (if not done with  POGO).
	//------------------------------------------------------------------

	//	Read device properties from database.(Automatic code generation)
	//------------------------------------------------------------------
	Tango::DbData	dev_prop;
	dev_prop.push_back(Tango::DbDatum("CurrentSourceProxyName"));
	dev_prop.push_back(Tango::DbDatum("VoltageCompliance"));

	//	Call database and extract values
	//--------------------------------------------
	if (Tango::Util::instance()->_UseDb==true)
		get_db_device()->get_property(dev_prop);
	Tango::DbDatum	def_prop, cl_prop;
	Keithley6221Class	*ds_class =
		(static_cast<Keithley6221Class *>(get_device_class()));
	int	i = -1;

	//	Try to initialize CurrentSourceProxyName from class property
	cl_prop = ds_class->get_class_property(dev_prop[++i].name);
	if (cl_prop.is_empty()==false)	cl_prop  >>  currentSourceProxyName;
	else {
		//	Try to initialize CurrentSourceProxyName from default device value
		def_prop = ds_class->get_default_device_property(dev_prop[i].name);
		if (def_prop.is_empty()==false)	def_prop  >>  currentSourceProxyName;
	}
	//	And try to extract CurrentSourceProxyName value from database
	if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  currentSourceProxyName;

	//	Try to initialize VoltageCompliance from class property
	cl_prop = ds_class->get_class_property(dev_prop[++i].name);
	if (cl_prop.is_empty()==false)	cl_prop  >>  voltageCompliance;
	else {
		//	Try to initialize VoltageCompliance from default device value
		def_prop = ds_class->get_default_device_property(dev_prop[i].name);
		if (def_prop.is_empty()==false)	def_prop  >>  voltageCompliance;
	}
	//	And try to extract VoltageCompliance value from database
	if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  voltageCompliance;



	//	End of Automatic code generation
	//------------------------------------------------------------------

	//- check the device name
	if (currentSourceProxyName.empty() == true)
	{
		ERROR_STREAM << "The socket device name must be filled" << std::endl;
		THROW_DEVFAILED(_CPTC("CONFIGURATION_ERROR"),
			_CPTC("The socket device name must be filled"),
			_CPTC("Keithley6221::get_device_property "));
	}
	//- check the compliance value
	if (voltageCompliance <= 0 || voltageCompliance > 105)
	{
		ERROR_STREAM << "The voltage compliance must be between 0.1 and 105 in 0.10 steps" << std::endl;
		THROW_DEVFAILED(_CPTC("CONFIGURATION_ERROR"),
			_CPTC("The voltage compliance must be between 0.1 and 105 in 0.10 steps"),
			_CPTC("Keithley6221::get_device_property "));
	}
}
//+----------------------------------------------------------------------------
//
// method : 		Keithley6221::always_executed_hook()
// 
// description : 	method always executed before any command is executed
//
//-----------------------------------------------------------------------------
void Keithley6221::always_executed_hook()
{
	
}
//+----------------------------------------------------------------------------
//
// method : 		Keithley6221::read_attr_hardware
// 
// description : 	Hardware acquisition for attributes.
//
//-----------------------------------------------------------------------------
void Keithley6221::read_attr_hardware(vector<long> &attr_list)
{
	//DEBUG_STREAM << "Keithley6221::read_attr_hardware(vector<long> &attr_list) entering... "<< endl;
	//	Add your own code here
}


//+------------------------------------------------------------------
/**
*	method:	Keithley6221::dev_state
*
*	description:	method to execute "State"
*	This command gets the device state (stored in its <i>device_state</i> data member) and returns it to the caller.
*
* @return	State Code
*
*/
//+------------------------------------------------------------------
Tango::DevState Keithley6221::dev_state()
{
	Tango::DevState s = Tango::UNKNOWN;
	
  if (m_init_ok == false)
	{
		this->set_state(Tango::FAULT);
		return Tango::FAULT;
	}
	
  if (m_interface != NULL)
	{
		int l_status = 0;
		
    try
		{
		  bool l_state = m_interface->read_output_state();
				
		  if (l_state == false)
				{
					s = Tango::STANDBY;
					m_status = "Device is up and ready";
				}
				else
				{
					s = Tango::RUNNING;
					m_status = "Current is being delivered";
				}
			l_status = m_interface->read_measurement_status();
			if (l_status == 8)
			{
				m_compStatus = "COMPLIANCE";
				s = Tango::ALARM;
			}
			else
			{
				m_compStatus = "NO COMPLIANCE";
			}

			std::string l_err = m_interface->read_errors();
			
      if (l_err.size() != 0 && l_err[0] != '0')
			{
				s = Tango::FAULT;
				m_currStatus = l_err;
			}
			
		}
		catch (...)
		{
			s = Tango::FAULT;
			m_status = "Problem communicating with the socket device";
			m_compStatus = "Unknown";
			m_currStatus = "Unknown";
		}
	}
	
  this->set_state(s);
	
  return s;
}
//+------------------------------------------------------------------
/**
*	method:	Keithley6221::dev_status
*
*	description:	method to execute "Status"
*	This command gets the device status (stored in its <i>device_status</i> data member) and returns it to the caller.
*
* @return	Status description
*
*/
//+------------------------------------------------------------------
Tango::ConstDevString Keithley6221::dev_status()
{
	static std::string s = "";
	yat::OSStream oss;
	oss << "DEVICE STATUS: " << m_status.c_str()
		<< std::endl
		<< "OUTPUT STATUS: " << m_compStatus.c_str()
		<< std::endl
		<< "CURRENT STATUS: " << m_currStatus.c_str()
		<< std::endl;
	s = oss.str();

	return s.c_str();
}
//+----------------------------------------------------------------------------
//
// method : 		Keithley6221::read_AutoRange
// 
// description : 	Extract real attribute values for AutoRange acquisition result.
//
//-----------------------------------------------------------------------------
void Keithley6221::read_autoRange(Tango::Attribute &attr)
{
	CHECK_INTERFACE;

	//DEBUG_STREAM << "Keithley6221::read_autoRange(Tango::Attribute &attr) entering... "<< endl;
	Tango::DevState st = this->dev_state();

	if (st != Tango::FAULT)
	{
		try
		{
			m_autoRange = m_interface->read_autorange();
		}
		catch (...)
		{
			set_state(Tango::FAULT);
			m_status = "Problem communicating with the socket device";
			THROW_DEVFAILED(_CPTC("DEVICE_ERROR"),
				_CPTC("Problem communicating with the socket device"),
				_CPTC("Keithley6221::read_autoRange"));
		}
		attr.set_value(&m_autoRange);
	}
}

//+----------------------------------------------------------------------------
//
// method : 		Keithley6221::read_Current
// 
// description : 	Extract real attribute values for Current acquisition result.
//
//-----------------------------------------------------------------------------
void Keithley6221::read_current(Tango::Attribute &attr)
{
	CHECK_INTERFACE
	//DEBUG_STREAM << "Keithley6221::read_Current(Tango::Attribute &attr) entering... "<< endl;
	Tango::DevState st = this->dev_state();
	if (st != Tango::FAULT)
	{
		try
		{
			m_current = m_interface->read_current();
			int l_coeff = m_interface->get_coeff_for_range(m_range);
			m_current *= l_coeff;
		}
		catch (...)
		{
			set_state(Tango::FAULT);
			m_status = "Problem communicating with the socket device";
			THROW_DEVFAILED(_CPTC("DEVICE_ERROR"),
				_CPTC("Problem communicating with the socket device"),
				_CPTC("Keithley6221::read_range"));
		}
		attr.set_value(&m_current);
	}
}

//+----------------------------------------------------------------------------
//
// method : 		Keithley6221::write_Current
// 
// description : 	Write Current attribute values to hardware.
//
//-----------------------------------------------------------------------------
void Keithley6221::write_current(Tango::WAttribute &attr)
{
	CHECK_INTERFACE;
	DEBUG_STREAM << "Keithley6221::write_Current(Tango::WAttribute &attr) entering... "<< endl;

	Tango::DevState st = this->dev_state();

	if (st == Tango::FAULT) 
	{
		THROW_DEVFAILED(
			_CPTC("BAD_STATE"),
			_CPTC("Action not allowed in this state - Device must not be in <FAULT>"),
			_CPTC("Keithley6221::write_current"));
	}
	try
	{
		double l_current;
		attr.get_write_value(l_current);
		int l_coeff = m_interface->get_coeff_for_range(m_range);
		m_interface->write_current(l_current / l_coeff);
	}
	catch (...)
	{
		set_state(Tango::FAULT);
		m_status = "Problem communicating with the socket device";
		THROW_DEVFAILED(_CPTC("DEVICE_ERROR"),
			_CPTC("Problem communicating with the socket device"),
			_CPTC("Keithley6221::write_current"));
	}
	m_currStatus = "No Errors";
}

//+----------------------------------------------------------------------------
//
// method : 		Keithley6221::read_Range
// 
// description : 	Extract real attribute values for Range acquisition result.
//
//-----------------------------------------------------------------------------
void Keithley6221::read_range(Tango::Attribute &attr)
{
	CHECK_INTERFACE
	//DEBUG_STREAM << "Keithley6221::read_range(Tango::Attribute &attr) entering... "<< endl;
	Tango::DevState st = this->dev_state();

	if (st != Tango::FAULT)
	{
		try
		{
			m_range = Tango::string_dup(m_interface->read_range().data());
		}
		catch (...)
		{
			set_state(Tango::FAULT);
			m_status = "Problem communicating with the socket device";
			THROW_DEVFAILED(_CPTC("DEVICE_ERROR"),
				_CPTC("Problem communicating with the socket device"),
				_CPTC("Keithley6221::read_range"));
		}
		attr.set_value(&m_range);
	}
}



//+------------------------------------------------------------------
/**
 *	method:	Keithley6221::auto_range_off
 *
 *	description:	method to execute "AutoRangeOFF"
 *	Sets the autoRange OFF
 *
 *
 */
//+------------------------------------------------------------------
void Keithley6221::auto_range_off()
{
	CHECK_INTERFACE;

	DEBUG_STREAM << "Keithley6221::auto_range_off(): entering... !" << endl;
	Tango::DevState st = this->dev_state();

	//	Add your own code to control device here
	if (st != Tango::FAULT)
	{
		if (m_autoRange == true)
		{
			try
			{
				m_interface->write_autorange(false);
			}
			catch (...)
			{
				set_state(Tango::FAULT);
				m_status = "Problem communicating with the socket device";
				THROW_DEVFAILED(_CPTC("DEVICE_ERROR"),
					_CPTC("Problem communicating with the socket device"),
					_CPTC("Keithley6221::auto_range_off"));
			}
			m_autoRange = false;
		}
	}
	else
	{
		THROW_DEVFAILED(
			_CPTC("BAD_STATE"),
			_CPTC("Action not allowed in this state - Device must not be in <FAULT>"),
			_CPTC("Keithley6221::auto_range_off"));
	}
}

//+------------------------------------------------------------------
/**
 *	method:	Keithley6221::auto_range_on
 *
 *	description:	method to execute "AutoRangeON"
 *	Sets the autoRange ON
 *
 *
 */
//+------------------------------------------------------------------
void Keithley6221::auto_range_on()
{
	CHECK_INTERFACE;

	DEBUG_STREAM << "Keithley6221::auto_range_on(): entering... !" << endl;
	Tango::DevState st = this->dev_state();

	//	Add your own code to control device here
	if (st != Tango::FAULT)
	{
		if (m_autoRange == false)
		{
			try
			{
				m_interface->write_autorange(true);
			}
			catch (...)
			{
				set_state(Tango::FAULT);
				m_status = "Problem communicating with the socket device";
				THROW_DEVFAILED(_CPTC("DEVICE_ERROR"),
					_CPTC("Problem communicating with the socket device"),
					_CPTC("Keithley6221::auto_range_on"));
			}
			m_autoRange = true;
		}
	}
	else
	{
		THROW_DEVFAILED(
			_CPTC("BAD_STATE"),
			_CPTC("Action not allowed in this state - Device must not be in <FAULT>"),
			_CPTC("Keithley6221::auto_range_on"));
	}
	m_currStatus = "No Errors";
}

//+------------------------------------------------------------------
/**
 *	method:	Keithley6221::get_range
 *
 *	description:	method to execute "GetRange"
 *	This command returns the value of the range attribute
 *
 * @return	Value of the range attribute
 *
 */
//+------------------------------------------------------------------
Tango::DevString Keithley6221::get_range()
{
	//	POGO has generated a method core with argout allocation.
	//	If you would like to use a static reference without copying,
	//	See "TANGO Device Server Programmer's Manual"
	//		(chapter : Writing a TANGO DS / Exchanging data)
	//------------------------------------------------------------
	CHECK_INTERFACE;

	DEBUG_STREAM << "Keithley6221::get_range(): entering... !" << endl;
	Tango::DevState st = this->dev_state();
	Tango::DevString argout;
	//	Add your own code to control device here
	if (st != Tango::FAULT)
	{
		try
		{
			m_range = Tango::string_dup(m_interface->read_range().data());
		}
		catch (...)
		{
			set_state(Tango::FAULT);
			m_status = "Problem communicating with the socket device";
			THROW_DEVFAILED(_CPTC("DEVICE_ERROR"),
				_CPTC("Problem communicating with the socket device"),
				_CPTC("Keithley6221::get_range"));
		}
		return Tango::string_dup(m_range);
	}
	else
	{
		THROW_DEVFAILED(
			_CPTC("BAD_STATE"),
			_CPTC("Action not allowed in this state - Device must not be in <FAULT>"),
			_CPTC("Keithley6221::get_range"));
	}
	return argout;
}

//+------------------------------------------------------------------
/**
 *	method:	Keithley6221::off
 *
 *	description:	method to execute "Off"
 *	The output is not activated
 *
 *
 */
//+------------------------------------------------------------------
void Keithley6221::off()
{
	CHECK_INTERFACE;

	DEBUG_STREAM << "Keithley6221::off(): entering... !" << endl;

	//	Add your own code to control device here
	Tango::DevState st = this->get_state();

	if ((st == Tango::FAULT) ||
      (st == Tango::STANDBY))
	{
		THROW_DEVFAILED(
			_CPTC("BAD_STATE"),
			_CPTC("Action not allowed in this state - Device must not be <FAULT> nor <STANDBY>"),
			_CPTC("Keithley6221::off"));
	}

  try
  {
	  m_interface->off();
  }
  catch (...)
  {
	  set_state(Tango::FAULT);
	  m_status = "Problem communicating with the socket device";
	  THROW_DEVFAILED(_CPTC("DEVICE_ERROR"),
		  _CPTC("Problem communicating with the socket device"),
		  _CPTC("Keithley6221::off"));
  }
}

//+------------------------------------------------------------------
/**
 *	method:	Keithley6221::on
 *
 *	description:	method to execute "On"
 *	The output is activated
 *
 *
 */
//+------------------------------------------------------------------
void Keithley6221::on()
{
	CHECK_INTERFACE;

	DEBUG_STREAM << "Keithley6221::on(): entering... !" << endl;

	//	Add your own code to control device here
	Tango::DevState st = this->get_state();

	if ((st == Tango::FAULT) ||
      (st == Tango::ALARM) || 
      (st == Tango::RUNNING))
	{
		THROW_DEVFAILED(
			_CPTC("BAD_STATE"),
			_CPTC("Action not allowed in this state - Device must be <STANDBY>"),
			_CPTC("Keithley6221::on"));
	}

	try
	{
		m_interface->on();
	}
	catch (...)
	{
		set_state(Tango::FAULT);
		m_status = "Problem communicating with the socket device";
		THROW_DEVFAILED(_CPTC("DEVICE_ERROR"),
			_CPTC("Problem communicating with the socket device"),
			_CPTC("Keithley6221::on"));
	}
}

//+------------------------------------------------------------------
/**
 *	method:	Keithley6221::range_down
 *
 *	description:	method to execute "RangeDOWN"
 *	This command sets the lower range
 *
 *
 */
//+------------------------------------------------------------------
void Keithley6221::range_down()
{
	CHECK_INTERFACE;

	DEBUG_STREAM << "Keithley6221::range_down(): entering... !" << endl;

	//	Add your own code to control device here
	Tango::DevState st = this->get_state();

	if (st == Tango::FAULT) 
	{
		THROW_DEVFAILED(
			_CPTC("BAD_STATE"),
			_CPTC("Action not allowed in this state - Device must not be in <FAULT>"),
			_CPTC("Keithley6221::range_down"));
	}

	if (m_autoRange == false)
	{
		std::string l_str;
		l_str = this->get_lower_range();

		try
		{
			m_interface->write_range(l_str);
		}
		catch (...)
		{
			set_state(Tango::FAULT);
			m_status = "Problem communicating with the socket device";
			THROW_DEVFAILED(_CPTC("DEVICE_ERROR"),
				_CPTC("Problem communicating with the socket device"),
				_CPTC("Keithley6221::range_down"));
		}
		m_range =  Tango::string_dup(m_interface->get_readable_range_from_set(l_str).data());
	}
	else
	{
		THROW_DEVFAILED(_CPTC("COMMAND FAILURE"),
			_CPTC("RangeDown not possible when autorange is ON"),
			_CPTC("Keithley6221::range_down"));
	}

}

//+------------------------------------------------------------------
/**
 *	method:	Keithley6221::range_up
 *
 *	description:	method to execute "RangeUP"
 *	This command sets the upper range
 *
 *
 */
//+------------------------------------------------------------------
void Keithley6221::range_up()
{
	CHECK_INTERFACE;

	DEBUG_STREAM << "Keithley6221::range_up(): entering... !" << endl;

	//	Add your own code to control device here
	Tango::DevState st = this->get_state();

	if (st == Tango::FAULT) 
	{
		THROW_DEVFAILED(
			_CPTC("BAD_STATE"),
			_CPTC("Action not allowed in this state - Device must not be in <FAULT>"),
			_CPTC("Keithley6221::range_up"));
	}

	if (m_autoRange == false)
	{
		std::string l_str;
		l_str = this->get_upper_range();
		try
		{
			m_interface->write_range(l_str);
		}
		catch (...)
		{
			set_state(Tango::FAULT);
			m_status = "Problem communicating with the socket device";
			THROW_DEVFAILED(_CPTC("DEVICE_ERROR"),
				_CPTC("Problem communicating with the socket device"),
				_CPTC("Keithley6221::range_up"));
		}
		m_range =  Tango::string_dup(m_interface->get_readable_range_from_set(l_str).data());
	}
	else
	{
		THROW_DEVFAILED(_CPTC("COMMAND FAILURE"),
			_CPTC("RangeUp not possible when autorange is ON"),
			_CPTC("Keithley6221::range_up"));
	}
}

//+------------------------------------------------------------------
/**
*	method:	Keithley6221::get_upper_range
*
*	description:	get the upper range
*	This command returns the value of the upper range 
*
* @return	Value of the upper range
*
*/
//+------------------------------------------------------------------
std::string Keithley6221::get_upper_range()
{
	DEBUG_STREAM << "Keithley6221::get_upper_range(): entering... !" << endl;
	//	Add your own code to control device here
	std::string l_str;
	if (strcmp(m_range,RR100MA) == 0)
	{
		l_str = SETRANGE100MA;
	}
	if (strcmp(m_range,RR20MA) == 0)
	{
		l_str = SETRANGE100MA;
	}
	if (strcmp(m_range,RR2MA) == 0)
	{
		l_str = SETRANGE20MA;
	}
	if (strcmp(m_range,RR200UA) == 0)
	{
		l_str = SETRANGE2MA;
	}
	if (strcmp(m_range,RR20UA) == 0)
	{
		l_str = SETRANGE200UA;
	}
	if (strcmp(m_range,RR2UA) == 0)
	{
		l_str = SETRANGE20UA;
	}
	if (strcmp(m_range,RR200NA) == 0)
	{
		l_str = SETRANGE2UA;
	}
	if (strcmp(m_range,RR20NA) == 0)
	{
		l_str = SETRANGE200NA;
	}
	if (strcmp(m_range,RR2NA) == 0)
	{
		l_str = SETRANGE20NA;
	}
	return l_str;
}

//+------------------------------------------------------------------
/**
*	method:	Keithley6221::get_lower_range
*
*	description:	get the lower range
*	This command returns the value of the lower range 
*
* @return	Value of the lower range
*
*/
//+------------------------------------------------------------------
std::string Keithley6221::get_lower_range()
{
	DEBUG_STREAM << "Keithley6221::get_lower_range(): entering... !" << endl;
	//	Add your own code to control device here
	std::string l_str;

	if (strcmp(m_range,RR100MA) == 0)
	{
		l_str = SETRANGE20MA;
	}
	if (strcmp(m_range,RR20MA) == 0)
	{
		l_str = SETRANGE2MA;
	}
	if (strcmp(m_range,RR2MA) == 0)
	{
		l_str = SETRANGE200UA;
	}
	if (strcmp(m_range,RR200UA) == 0)
	{
		l_str = SETRANGE20UA;
	}
	if (strcmp(m_range,RR20UA) == 0)
	{
		l_str = SETRANGE2UA;
	}
	if (strcmp(m_range,RR2UA) == 0)
	{
		l_str = SETRANGE200NA;
	}
	if (strcmp(m_range,RR200NA) == 0)
	{
		l_str = SETRANGE20NA;
	}
	if (strcmp(m_range,RR20NA) == 0)
	{
		l_str = SETRANGE2NA;
	}
	if (strcmp(m_range,RR2NA) == 0)
	{
		l_str = SETRANGE2NA;
	}
	return l_str;
}
}	//	namespace
